## ld.so 1.8.5-1

=== Makefile ===
include Version.mk
include Config.mk

SUBDIRS = man util d-link
ifeq ($(AOUT_SUPPORT),true)
SUBDIRS += ld-so
endif
ifeq ($(ARCH),i386)
SUBDIRS += test
endif

all:
	set -e ; for d in $(SUBDIRS) ; do $(MAKE) -C $$d ; done

install: all
	sh instldso.sh

clean:
	set -e ; for d in $(SUBDIRS) ; do $(MAKE) -C $$d $@ ; done
	rm -f *~

dist:
	$(MAKE) clean
	$(MAKE) all
	find . -name '*.o' | xargs rm
	cd .. && \
	tar cvf ld.so-$(VERSION).tar ld.so-$(VERSION) && \
	gzip -v9 ld.so-$(VERSION).tar

=== ld-so/Makefile ===
include ../Version.mk
include ../Config.mk

ALL = ld.so

all:	$(ALL)

ld.so: 	preld.o ld.so.o fixups.o fdprintf.o vsprintf.o \
	unsetenv.o strerror.o preload.o
	$(CC) -static -nostdlib -Wl,-Ttext,$(LDSO_ADDR),-T,ldso.link \
		-o $@ $^ -lc -lgcc

clean:
	rm -f $(ALL) *.o *~ core
	rm -f $(STATIC_DIR)/*.o

=== test/Makefile ===
include ../Version.mk
include ../Config.mk

ifeq ($(AOUT_SUPPORT),true)
AOUT_ALL = atesti atestf
endif

ALL = etesti etestf $(AOUT_ALL)

all: $(ALL)

etesti: testi.c
	$(CC) -Wl,-dynamic-linker,../d-link/ld-linux.so $^ -o $@

etestf: testf.c
	$(CC) -Wl,-dynamic-linker,../d-link/ld-linux.so $^ -lm -o $@

atesti: atesti.save
	ln -f $< $@

atestf: atestf.save
	ln -f $< $@

atesti.save: testi.c __load.c
	$(AOUTCC) -DLDSO_ADDR=$(LDSO_ENTRY) $^ -o $@

atestf.save: testf.c __load.c
	$(AOUTCC) -DLDSO_ADDR=$(LDSO_ENTRY) $^ -lm -o $@

clean:
	rm -f $(ALL) *.o *~ core

=== d-link/libdl/Makefile ===
include ../../Version.mk
include ../../Config.mk

CFLAGS += -I.. -I../$(ARCH) -DNO_UNDERSCORE -DVERBOSE_DLINKER -DUSE_CACHE
CFLAGS += -fPIC -D__PIC__ #-funroll-loops

SRC2S = dlib.c

SRCS	= $(SRC1S) $(SRC2S)
OBJ1S	= $(SRC1S:.S=.o)
OBJ2S	= $(SRC2S:.c=.o)
OBJS	= $(OBJ1S) $(OBJ2S)

LIBDL = libdl.so

ELF_LDFLAGS=--shared -nostartfiles -nostdlib # using GNU ld
#ELF_LDFLAGS=-G  # with SVr4 ld

lib:: $(OBJS)
	$(CC) $(ELF_LDFLAGS) -o $(LIBDL) -Wl,-soname -Wl,libdl.so.$(VMAJOR) *.o

obj: $(OBJS)

realclean::
	$(RM) -f .depend $(LIBDL) core *.o *.a *.s *.i tmp_make foo *~

clean::
	$(RM) -f $(LIBDL) core *.o *.a *.s *.i tmp_make foo *~

depend::
	$(CC) $(CFLAGS) -M $(SRCS) | \
		sed -e 's,^[ 	]*\(.*.o\)[ 	]*:,$(STATIC_DIR)/$(SUBDIR)/\1 $(SHARED_DIR)/$(SUBDIR)/\1 $(SHARED_LITE_DIR)/$(SUBDIR)/\1 $(DEBUG_DIR)/$(SUBDIR)/\1 $(PROFILE_DIR)/$(SUBDIR)/\1 $(CHECKER_DIR)/$(SUBDIR)/\1:,' > .depend
#	$(MAKE) subdir TARGET=depend

ifneq ($(DIRS),)
lib realclean clean depend::
	@for i in $(DIRS); do \
	  echo making $@ in $$i; \
	  ($(MAKE) -C $$i $@); \
	done;
endif

#
# include a dependency file if one exists
#
ifeq (.depend,$(wildcard .depend))
include .depend
endif

=== d-link/sparc/Makefile ===
include ../../Version.mk
include ../../Config.mk

CFLAGS += -I.. -I. -DNO_UNDERSCORE -DVERBOSE_DLINKER
CFLAGS += -fPIC -D__PIC__ #-DDEBUG # -funroll-loops

../%.o: %.S
	$(CC) $(CFLAGS) -D__ASSEMBLY__ -c $< -o $@
../%.o: %.c
	$(CC) $(CFLAGS) -c $< -o $@

# udiv.S umul.S  
# 
SRC1S = resolve.S  urem.S sdiv.S
SRC2S = elfinterp.c

SRCS	= $(SRC1S) $(SRC2S)
OBJ1S	= $(SRC1S:.S=.o)
OBJ2S	= $(SRC2S:.c=.o)
OBJS	= $(OBJ1S) $(OBJ2S)

DLINK_OBJS:= $(addprefix ../, $(OBJS))

lib:: $(DLINK_OBJS)

obj: $(DLINK_OBJS)

asm: $(ASMS)

realclean::
	$(RM) -f .depend core *.o *.a *.s *.i tmp_make *~

clean::
	$(RM) -f core *.o *.a *.s *.i tmp_make *~

depend::
	$(CC) $(CFLAGS) -M $(SRCS) | \
		sed -e 's,^[ 	]*\(.*\.o\)[ 	]*:,../\1:,' > .depend
#	$(MAKE) subdir TARGET=depend

#
# include a dependency file if one exists
#
ifeq (.depend,$(wildcard .depend))
include .depend
endif

## ld.so 1.8.12-1

=== debian/changelog ===
ld.so (1.8.12-1) stable; urgency=high

  * Fixed a bug in ld.so introduced in the previous version
    which broke preloads.

 -- David Engel <david@sw.ods.com>  Sat, 26 Jul 1997 13:57:52 -0500

ld.so (1.8.11-1) stable; urgency=high

  * Fixed buffer overflow bugs in ld-linux.so and ld.so.

 -- David Engel <david@sw.ods.com>  Mon, 21 Jul 1997 19:39:00 -0500

ld.so (1.8.10-2) unstable; urgency=low

  * Changed the shlibs file so other packages would depend on ldso
    instead of libdl1.

 -- David Engel <david@sw.ods.com>  Mon, 3 Mar 1997 11:40:34 -0600

ld.so (1.8.10-1) stable unstable; urgency=low

  * Fixed a bug in ldconfig where a symlink could be used
    instead of a regular file.

  * Fixed a Debian packaging problem for the sparc 
    architecture.

 -- David Engel <david@debian.org>  Tue, 18 Feb 1997 20:49:23 -0600

ld.so (1.8.9-1) unstable; urgency=low

  * Changed ldconfig to only cache the symlinks it creates.
    This make the behavior of the dynamic linkers consistent
     with how they would behave if a cache was not used.

  * Changed ldconfig to cache the symlinks that it finds but
    use the name of the symlink as the soname instead of the 
    actual soname.

 -- David Engel <david@debian.org>  Sun, 9 Feb 1997 00:32:25 -0600

ld.so (1.8.8-1) stable unstable; urgency=low

  * Minor documentation updates to reflect recent changes.

  * Changed ld.so and ld-linux.so to perform more complete
    validation on ld.so.cache before using it.

  * Changed ldconfig to accept libraries with inconsistent
    sonames since glibc is going to use them.  A warning is
    still printed in debug mode.

  * Changed the install script to not strip _dl_debug_state
    from ld-linux.so since gdb needs it.

  * More sparc fixes (Derrick Brashear).

  * Changed ldconfig to not issue a warning when a linker
    script disguised as a shared library is found.

  * Fixed a bug in ld-linux.so where some registers were 
    not preserved on the first call to a function causing 
    problems for non-C-like languages (Tim Renouf).

  * Fixed a bug in ld-linux.so where global variables were 
    not always mapped correctly across dynamically loaded 
    libraries (Mikihiko Nakao).

  * Converted to new Debian source packaging format (Shaya
    Potter).

 -- David Engel <david@debian.org>  Sat, 25 Jan 1997 23:30:10 -0600

Local variables:
mode: debian-changelog
End:

## ld.so 1.9.9-1

=== d-link/i386/Makefile ===
include ../../Version.mk
include ../../Config.mk

CFLAGS += -I.. -I. -DNO_UNDERSCORE -DVERBOSE_DLINKER
CFLAGS += -fPIC -D__PIC__ #-DDEBUG # -funroll-loops

../%.o: %.S
	$(CC) $(CFLAGS) -c $< -o $@
../%.o: %.c
	$(CC) $(CFLAGS) -c $< -o $@

SRC1S = resolve.S
SRC2S = elfinterp.c

SRCS	= $(SRC1S) $(SRC2S)
OBJ1S	= $(SRC1S:.S=.o)
OBJ2S	= $(SRC2S:.c=.o)
OBJS	= $(OBJ1S) $(OBJ2S)

DLINK_OBJS:= $(addprefix ../, $(OBJS))

lib:: $(DLINK_OBJS)

obj: $(DLINK_OBJS)

asm: $(ASMS)

realclean::
	$(RM) -f .depend core *.o *.a *.s *.i tmp_make *~

clean::
	$(RM) -f core *.o *.a *.s *.i tmp_make *~

depend::
	$(CC) $(CFLAGS) -M $(SRCS) | \
		sed -e 's,^[ 	]*\(.*\.o\)[ 	]*:,../\1:,' > .depend
#	$(MAKE) subdir TARGET=depend

#
# include a dependency file if one exists
#
ifeq (.depend,$(wildcard .depend))
include .depend
endif

## ld.so 1.9.10-1

=== util/Makefile ===
include ../Version.mk
include ../Config.mk

ALL	= ldconfig
ifeq ($(LIBC5_SUPPORT),true)
ALL	+= ldd lddstub elf-ok
endif

all:	$(ALL)

ldconfig: ldconfig.o readelf.o
	$(CC) -static $(CFLAGS) $(LDFLAGS) $^ -o $@

ldd:	ldd.o readelf.o
	$(CC) -static $(CFLAGS) $(LDFLAGS) $^ -o $@

ldd.o:	ldd.c
	$(CC) -c $(CFLAGS) -DLDSO_ADDR=$(LDSO_ENTRY) $< -o $@

ifeq ($(DEBUG),true)
STUBFLAGS = -Wl,-dynamic-linker,../d-link/ld-linux.so
endif

lddstub: lddstub.o
	$(LIBC5_CC) $(CFLAGS) $(LDFLAGS) $(STUBFLAGS) $^ -o $@

elf-ok: elf-ok.S
	$(CC) $(CFLAGS) -nostartfiles -static -s $^ -o $@

clean:
	rm -f $(ALL) *.o *~ core

=== debian/changelog ===
ld.so (1.9.10-1) frozen unstable; urgency=low

  * Changed ldconfig to issue a warning and not overwrite a
    regular file with a symlink (Bug#30859).
  * Changed Debian packaging to conflict with and replace the
    ldconfig package (Bug#29398).

 -- David Engel <david@debian.org>  Wed, 13 Jan 1999 20:11:18 -0600

ld.so (1.9.9-5) unstable; urgency=low

  * Fixed build problems on non-libc5 architectures (Bug#25493
    and Bug#25496).

 -- David Engel <david@debian.org>  Sat,  8 Aug 1998 21:53:14 -0500

ld.so (1.9.9-4) unstable; urgency=low

  * Replaced extraneous spaces in debian/rules with tabs
    (Bug#25348).

 -- David Engel <david@debian.org>  Wed,  5 Aug 1998 21:37:59 -0500

ld.so (1.9.9-3) unstable; urgency=low

  * Moved ldconfig back into the ldso package.

 -- David Engel <david@debian.org>  Thu,  9 Jul 1998 19:51:25 -0500

ld.so (1.9.9-2) unstable; urgency=low

  * Split ldconfig into it's own package and made the ldso and
    libdl1-dev packages to not contain anything for those 
    architectures which don't need them until the relavent 
    dependencies can be changed (Bug#24156)..

 -- David Engel <david@debian.org>  Wed,  8 Jul 1998 21:07:53 -0500

ld.so (1.9.9-1) frozen unstable; urgency=low

  * Changed ld-linux.so and libdl.so to match glibc by not
    allowing user preloads of system libraries into setu/gid
    binaries unless the library itself is setuid.
  * Fixed problems in ld-linux.so on the sparc architecture
    (Juan Cespedes).

 -- David Engel <david@sw.ods.com>  Thu, 21 May 1998 10:56:20 -0500

ld.so (1.9.8-1) frozen unstable; urgency=low

  * Changed ldconfig to allow the expected type for all
    libraries in a directory to be optionally specified
    (Mark Phillips).  See the ldconfig man page.
  * Changed ldconfig to use the same type names used in the
    change above when the -p option is used.

 -- David Engel <david@sw.ods.com>  Sun, 26 Apr 1998 13:50:28 -0500

ld.so (1.9.7-1) unstable; urgency=low

  * Changed ldd for m68k to use /lib/ld.so.1 instead of 
    /lib/ld-linux.so.2.
  * Added support for dladdr to libdl.so (Eduard Gode).
  * Fixed a small memory leak in libdl.so (Richard Garnish).
  * Fixed a bug in ldconfig when the -l option was used on a
    filename without a '/' in it.
  * Updated the man pages (Bug#6404, Bug#9721, Bug#10652, 
    Bug#13494 and Bug#14127).  They could still use some work.
  * No longer install the info page since it's way out of date.
  * Fixed minor Debian packaging problems (Bug#13160, 
    Bug#15577 and Bug#19345).

 -- David Engel <david@sw.ods.com>  Sat, 14 Mar 1998 22:08:21 -0600

ld.so (1.9.6-2) unstable; urgency=low

  * Changed ld-linux.so to be compilable with gcc 2.8.0 (Sven 
    Verdoolaege)

 -- David Engel <david@sw.ods.com>  Thu, 11 Sep 1997 13:40:37 -0500

ld.so (1.9.6-1) unstable; urgency=low

  * Changed ldd to not use the glibc dynamic linker when run
    on a libc5-based shared library.
  * Added a -q option to ldconfig which causes warnings not
    to be printed (Bob Tinsley).
  * Dropped support for the Debian libdl1-dev package.

 -- David Engel <david@sw.ods.com>  Wed, 10 Sep 1997 14:40:15 -0500

ld.so (1.9.5-1) unstable; urgency=low

  * Fixed a bug in ldd where ld-linux.so.2 was not called
    correctly when run on shared libraries.
  * Fixed a problem in the previous version where some
    Makefiles were not architecture independent.

 -- David Engel <david@sw.ods.com>  Tue,  5 Aug 1997 20:13:22 -0500

ld.so (1.9.4-1) unstable; urgency=high

  * Fixed a bug in ld.so introduced in the previous version
    which broke preloads.
  * Turned a.out support back on by default, at least for the
    time being.  There are no promises to keep it.

 -- David Engel <david@sw.ods.com>  Sat, 26 Jul 1997 14:21:23 -0500

ld.so (1.9.3-1) unstable; urgency=high

  * Fixed buffer overflow bugs in ld-linux.so and ld.so.
  * Changed the README file a little to clarify a couple of
    things.
  * Changed ldconfig to chroot to the specified directory when
    the new -r option is used (Bob Tinsley).

 -- David Engel <david@sw.ods.com>  Mon, 21 Jul 1997 15:55:13 -0500

ld.so (1.9.2-3) unstable; urgency=low

  * Added a warning in the description not to downgrade to 
    version 1.8.x or earlier.
  * Changed /etc/ld.so.conf to not be a dpkg "conf" file 
    (Bug#9722).
  * Fixed a typo in debian/rules which affected m68k builds 
    (Bug#10025).

 -- David Engel <david@sw.ods.com>  Tue, 27 May 1997 10:27:48 -0500

ld.so (1.9.2-2) unstable; urgency=low

  * Added a libdl1-altdev package which can coexist with the
    libc6-dev package.

 -- David Engel <david@sw.ods.com>  Fri, 2 May 1997 21:45:40 -0500

ld.so (1.9.2-1) unstable; urgency=low

  * Removed /usr/local/lib from the default /etc/ld.so.conf
    for Debian (Bug#8181).
  * Changed ldconfig to be 64-bit clean (H.J. Lu).

 -- David Engel <david@sw.ods.com>  Tue, 22 Apr 1997 19:56:26 -0500

ld.so (1.9.1-1) unstable; urgency=low

  * Changed ldconfig to try to determine which libc a
    library is for even if it doesn't have an soname.
  * Fixed a bug in ldconfig where an older library using
    the glibc naming convention would be used instead of
    a newer library.
  * Changed to ld-linux.so and libdl.so to not require the 
    libc5 headers in order to compile.
  * Changed ldconfig and ldd to be compilable with either
    libc5 or libc6.

 -- David Engel <david@sw.ods.com>  Tue, 18 Mar 1997 20:46:50 -0600

ld.so (1.9.0-1) unstable; urgency=low

  * Changed to not build the old, a.out dynamic loader by
    default.
  * Changed instldso.sh to require the --force option to
    make sure users read the README file.
  * Changed instldso.sh to not install the libdl.so
    development files unless the --devfiles option is used.
  * Changed instldso.sh to not strip binaries and libraries
    if the --no-strip option is used.
  * Changed the Debian packaging to put the development files 
    which conflict with glibc in a new libdl1-dev package.


=== debian/control ===
Source: ld.so
Section: base
Priority: required
Maintainer: David Engel <david@debian.org>
Standards-Version: 2.4.0.0

Package: ldso
Section: base
Priority: required
Essential: yes
Architecture: any
Provides: ldconfig, libdl1
Conflicts: ldconfig
Replaces: ldconfig
Description: The Linux dynamic linker, library and utilities.
 The dynamic linker provides the user-level support for loading and
 linking DLL and ELF shared libraries.  It is required by any program
 that uses shared libraries.
 .
 WARNING: Do NOT downgrade this package to version 1.8.x or earlier.
 Doing so may leave your system in an unusable state.

Package: libdl1-altdev
Section: devel
Priority: optional
Architecture: i386 m68k sparc
Depends: ldso (=${Source-Version}), libc5-altdev (>=5.4.0-0)
Description: The Linux dynamic linker library (libc5 altdev files).
 This package can be used to build libc5-based binaries even when 
 the libc6-dev package is installed.

=== debian/rules ===
#! /usr/bin/make -f
#
# Last updated: Thu Apr 26 22:00:00 CDT 1995 by david.
#
# To make the binary distribution package, the ``Debianized'' source package
# and the context diff to the original package, type `./debian.rules dist'.
# Make sure that `debian.rules' is executable before the final distribution
# is made.
#
# Invoke each target with `./debian.rules <target>'.  All targets should be
# invoked with the package root as the current directory.
#
# The `binary' target must be run as root, as it needs to install files with
# specific ownerships.  The `diff' target assumes that you have the original
# source package available, unpacked, in ../$(p)-$(v).orig, or that you have
# the previous revision of the ``Debianized'' source package and context diff
# in the parent directory.

include Version.mk
v = $(VERSION)
vm = $(VMAJOR)
ARCH = $(shell dpkg --print-architecture)
ifeq ($(ARCH),i386)
archx = i486
else
archx = $(ARCH)
endif

include Config.mk

build:
# Builds the binary package.
	make ARCH=$(ARCH) clean
	make ARCH=$(ARCH)
	touch build

clean:
# Undoes the effect of `make -f debian.rules build'.
	make ARCH=$(ARCH) clean
	rm -f build
	rm -rf debian/tmp debian/files

binary-indep:   checkroot build
	$(checkdir)

binary-arch:    checkroot build
	$(checkdir)
	#
	##############################
	# build the ldso package
	rm -rf debian/tmp
	install -d -m 755 debian/tmp
	chmod g-s debian/tmp
	#
	install -d -m 755 debian/tmp/sbin
	install -s -m 755 util/ldconfig debian/tmp/sbin/ldconfig.new
ifeq ($(LIBC5_SUPPORT),true)
	install -d -m 755 debian/tmp/usr/bin
	install -s -m 755 util/ldd debian/tmp/usr/bin/ldd
	install -d -m 755 debian/tmp/usr/lib
	install -s -m 755 util/lddstub debian/tmp/usr/lib/lddstub
endif
ifeq ($(AOUT_SUPPORT),true)
	install -d -m 755 debian/tmp/lib
	install -s -m 755 ld-so/ld.so debian/tmp/lib/ld.so.$(v)
endif
ifeq ($(LIBC5_SUPPORT),true)
	install -d -m 755 debian/tmp/lib
	install -m 755 d-link/ld-linux.so debian/tmp/lib/ld-linux.so.$(v)
	strip -g -K _dl_debug_state debian/tmp/lib/ld-linux.so.$(v)
	ln -sf ld-linux.so.$(v) debian/tmp/lib/ld-linux.so.$(vm)
	install -s -m 755 d-link/libdl/libdl.so debian/tmp/lib/libdl.so.$(v)
	ln -sf libdl.so.$(v) debian/tmp/lib/libdl.so.$(vm)
endif
	#
	install -d -m 755 debian/tmp/usr/man/man8
	install -m 644 man/ldconfig.8 debian/tmp/usr/man/man8/ldconfig.8
ifeq ($(LIBC5_SUPPORT),true)
	install -d -m 755 debian/tmp/usr/man/man1
	install -m 644 man/ldd.1 debian/tmp/usr/man/man1/ldd.1
	install -d -m 755 debian/tmp/usr/man/man8
	install -m 644 man/ld.so.8 debian/tmp/usr/man/man8/ld.so.8
	gzip -9 debian/tmp/usr/man/man*/*
endif
	#
	install -d -m 755 debian/tmp/usr/doc/ldso
	install -m 644 README debian/tmp/usr/doc/ldso/README
	install -m 644 debian/changelog debian/tmp/usr/doc/ldso/changelog
	gzip -9f debian/tmp/usr/doc/ldso/*
	install -m 644 debian/copyright debian/tmp/usr/doc/ldso/copyright
	#
	install -d -m 755 debian/tmp/DEBIAN
ifeq ($(LIBC5_SUPPORT),true)
	uuencode util/elf-ok elf-ok > /tmp/elf-ok.uue
	sed -e '/^__END__/r /tmp/elf-ok.uue' debian/preinst \
		> debian/tmp/DEBIAN/preinst
	rm -f /tmp/elf-ok.uue
else
	sed -e '/^#MARKER1/,/^#MARKER2/d' debian/preinst \
		> debian/tmp/DEBIAN/preinst
endif
	chmod 755 debian/tmp/DEBIAN/preinst
	sed -e 's/VERSION/$(VERSION)/' debian/postinst \
		> debian/tmp/DEBIAN/postinst
	chmod 755 debian/tmp/DEBIAN/postinst
ifeq ($(LIBC5_SUPPORT),true)
	install -m 644 debian/shlibs debian/tmp/DEBIAN/shlibs
endif
	#
	dpkg-gencontrol -pldso
	chmod -R g-w debian/tmp
	chown -R root.root debian/tmp
	dpkg --build debian/tmp ..
	#
	##############################
	# build the libdl1-altdev package
ifeq ($(LIBC5_SUPPORT),true)
	rm -rf debian/tmp
	install -d -m 755 debian/tmp
	chmod g-s debian/tmp
	#
	install -d -m 755 debian/tmp/usr/$(archx)-linuxlibc1/lib
	ln -sf /lib/libdl.so.$(v) \
		debian/tmp/usr/$(archx)-linuxlibc1/lib/libdl.so
	install -d -m 755 debian/tmp/usr/$(archx)-linuxlibc1/include
	install -m 644 d-link/libdl/dlfcn.h \
		debian/tmp/usr/$(archx)-linuxlibc1/include/dlfcn.h
	#
	install -d -m 755 debian/tmp/usr/doc
	ln -sf ldso debian/tmp/usr/doc/libdl1-altdev
	#
	install -d -m 755 debian/tmp/DEBIAN
	dpkg-gencontrol -plibdl1-altdev
	chmod -R g-w debian/tmp
	chown -R root.root debian/tmp
	dpkg --build debian/tmp ..
endif

binary: binary-indep binary-arch

checkroot:
	test root = "`whoami`"

.PHONY: binary binary-arch binary-indep clean checkroot

## ld.so 1.9.11-9

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,10 @@
 include Version.mk
 include Config.mk
 
-SUBDIRS = man util d-link
+SUBDIRS = man util
+ifeq ($(LIBC5_SUPPORT),true)
+SUBDIRS += d-link
+endif
 ifeq ($(AOUT_SUPPORT),true)
 SUBDIRS += ld-so
 endif
@@ -17,7 +20,7 @@
 
 clean:
 	set -e ; for d in $(SUBDIRS) ; do $(MAKE) -C $$d $@ ; done
-	rm -f *~
+	-find . -name '*~' | xargs rm -f
 
 dist:
 	$(MAKE) clean

=== d-link/Makefile ===
include ../Version.mk
include ../Config.mk

CC = $(LIBC5_CC)

DIRS = $(ARCH) libdl

CFLAGS += -I. -I./$(ARCH) -DNO_UNDERSCORE -DVERBOSE_DLINKER \
	-DUSE_CACHE -fPIC -D__PIC__ #-funroll-loops

SRC2S = boot1.c hash.c readelflib1.c vsprintf.c

SRCS	= $(SRC1S) $(SRC2S)
OBJ1S	= $(SRC1S:.S=.o)
OBJ2S	= $(SRC2S:.c=.o)
OBJS	= $(OBJ1S) $(OBJ2S)

DLINKER = ld-linux.so

ELF_LDFLAGS=--shared # using GNU ld
#ELF_LDFLAGS=-G  # with SVr4 ld

lib:: $(OBJS)
	@set -e; for i in $(DIRS); do \
	  echo making $@ in $$i; \
	  $(MAKE) -C $$i CC=$(CC) $@; \
	done;
	$(LD) -e _dl_boot $(ELF_LDFLAGS) -o $(DLINKER) \
	  -soname $(DLINKER).$(VMAJOR) *.o

obj: $(OBJS)

realclean::
	$(RM) -f .depend $(DLINKER) core *.o *.a *.s *.i tmp_make foo *~

clean::
	$(RM) -f $(DLINKER) core *.o *.a *.s *.i tmp_make foo *~

depend::
	$(CC) $(CFLAGS) -M $(SRCS) | \
		sed -e 's,^[ 	]*\(.*.o\)[ 	]*:,$(STATIC_DIR)/$(SUBDIR)/\1 $(SHARED_DIR)/$(SUBDIR)/\1 $(SHARED_LITE_DIR)/$(SUBDIR)/\1 $(DEBUG_DIR)/$(SUBDIR)/\1 $(PROFILE_DIR)/$(SUBDIR)/\1 $(CHECKER_DIR)/$(SUBDIR)/\1:,' > .depend
#	$(MAKE) subdir TARGET=depend

ifneq ($(DIRS),)
lib realclean clean depend::
	@set -e; for i in $(DIRS); do \
	  echo making $@ in $$i; \
	  $(MAKE) -C $$i CC=$(CC) $@; \
	done;
endif

#
# include a dependency file if one exists
#
ifeq (.depend,$(wildcard .depend))
include .depend
endif

=== ld-so/Makefile ===
--- 
+++ 
@@ -1,5 +1,7 @@
 include ../Version.mk
 include ../Config.mk
+
+CC = $(LIBC5_CC)
 
 ALL = ld.so

=== test/Makefile ===
--- 
+++ 
@@ -1,5 +1,7 @@
 include ../Version.mk
 include ../Config.mk
+
+CC = $(LIBC5_CC)
 
 ifeq ($(AOUT_SUPPORT),true)
 AOUT_ALL = atesti atestf

=== util/Makefile ===
--- 
+++ 
@@ -7,6 +7,8 @@
 endif
 
 all:	$(ALL)
+
+readelf.o: readelf.c readelf2.c
 
 ldconfig: ldconfig.o readelf.o
 	$(CC) -static $(CFLAGS) $(LDFLAGS) $^ -o $@

=== d-link/libdl/Makefile ===
--- 
+++ 
@@ -17,7 +17,7 @@
 #ELF_LDFLAGS=-G  # with SVr4 ld
 
 lib:: $(OBJS)
-	$(CC) $(ELF_LDFLAGS) -o $(LIBDL) -Wl,-soname -Wl,libdl.so.$(VMAJOR) *.o
+	$(CC) $(ELF_LDFLAGS) -o $(LIBDL) -Wl,-soname -Wl,libdl.so.$(VMAJOR) *.o -lc
 
 obj: $(OBJS)

=== debian/changelog ===
ld.so (1.9.11-9) frozen unstable; urgency=high

  * Reverted part of the previous change since other parts of
    the system are not ready for it (Bug#63485).

 -- David Engel <david@debian.org>  Wed,  3 May 2000 12:06:09 -0500

ld.so (1.9.11-8) frozen unstable; urgency=low

  * Included ldconfig changes from RedHat and David Huggins-Daines
    for 64-bit architectures (Bug#63183).
  * Include DEBIAN/md5sums file (Bug#62304).

 -- David Engel <david@debian.org>  Mon,  1 May 2000 21:36:49 -0500

ld.so (1.9.11-7) frozen unstable; urgency=low

  * Fixed sparc segfaults in ldconfig (again) by not using any 
    optimization.

 -- David Engel <david@debian.org>  Mon,  3 Apr 2000 20:49:41 -0500

ld.so (1.9.11-6) frozen unstable; urgency=low

  * Fixed sparc segfaults in ldconfig by compiling with lower
    optimization (Bug#59285 and Bug#61461).
  * Added minor manpage updates (Bug#56278 and Bug#57638).

 -- David Engel <david@debian.org>  Sun,  2 Apr 2000 20:04:58 -0500

ld.so (1.9.11-5) unstable; urgency=low

  * Fixed MIPS problem in ldconfig.
  * Worked around more libc6 ldd problems.

 -- David Engel <david@debian.org>  Mon, 25 Oct 1999 11:13:51 -0500

ld.so (1.9.11-4) unstable; urgency=low

  * FHS changes.

 -- David Engel <david@debian.org>  Sun,  3 Oct 1999 14:02:30 -0500

ld.so (1.9.11-3) unstable; urgency=high

  * Fixed segfaults caused by latent bugs and the previous NMU
    (Bug#45371, Bug#45396).

 -- David Engel <david@debian.org>  Fri, 17 Sep 1999 21:45:32 -0500

ld.so (1.9.11-2.1) unstable; urgency=low

  * Non-maintainer release.
  * Blah, glibc's ldd screws up on libc5 binaries,
    so use this one again on i386/m68k.
    - Add Replaces libc6 (<< 2.1.2-2).
  * sparc no longer wants libc5-compat packages.

 -- Joel Klecker <espy@debian.org>  Fri, 17 Sep 1999 08:51:34 -0700

ld.so (1.9.11-2) unstable; urgency=low

  * Fixed a typo in the last revision.

 -- David Engel <david@debian.org>  Tue,  4 May 1999 21:18:09 -0500

ld.so (1.9.11-1) unstable; urgency=low

  * Fixed a bug in ld-linux.so where a reference to an
    undefined symbol could cause a segfault.
  * Added a clarification for LD_PRELOAD to the ld.so manual 
    page and added a symlink for ld-linux.so (Bug#33123).
  * Don't install ldd for Debian except for the m68k arch
    because glibc 2.1 now includes it (Bug#35458).

 -- David Engel <david@debian.org>  Sat,  1 May 1999 22:10:48 -0500

ld.so (1.9.10-1.2) unstable; urgency=low

  * Non-maintainer upload.
  * Re-add provision of ldd for m68k, as we're not switching to glibc 2.1
    right now.

 -- James Troup <james@nocrew.org>  Sun, 28 Mar 1999 13:04:49 +0100

ld.so (1.9.10-1.1) unstable; urgency=low

  * Non-maintainer release for glibc 2.1.
  * No longer provide ldd even on libc5 archs
    (glibc 2.1's ldd supports libc6, libc5, and libc4 binaries
     where applicable).

 -- Joel Klecker <espy@debian.org>  Sun, 28 Feb 1999 04:21:07 -0800

  ld.so (1.9.10-1) frozen unstable; urgency=low

  * Changed ldconfig to issue a warning and not overwrite a
    regular file with a symlink (Bug#30859).
  * Changed Debian packaging to conflict with and replace the
    ldconfig package (Bug#29398).

 -- David Engel <david@debian.org>  Wed, 13 Jan 1999 20:11:18 -0600

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
 Architecture: any
 Provides: ldconfig, libdl1
 Conflicts: ldconfig
-Replaces: ldconfig
+Replaces: ldconfig, libc6
 Description: The Linux dynamic linker, library and utilities.
  The dynamic linker provides the user-level support for loading and
  linking DLL and ELF shared libraries.  It is required by any program
@@ -23,7 +23,7 @@
 Package: libdl1-altdev
 Section: devel
 Priority: optional
-Architecture: i386 m68k sparc
+Architecture: i386 m68k
 Depends: ldso (=${Source-Version}), libc5-altdev (>=5.4.0-0)
 Description: The Linux dynamic linker library (libc5 altdev files).
  This package can be used to build libc5-based binaries even when

=== debian/rules ===
--- 
+++ 
@@ -69,25 +69,28 @@
 	install -m 755 d-link/ld-linux.so debian/tmp/lib/ld-linux.so.$(v)
 	strip -g -K _dl_debug_state debian/tmp/lib/ld-linux.so.$(v)
 	ln -sf ld-linux.so.$(v) debian/tmp/lib/ld-linux.so.$(vm)
+ifneq ($(ARCH),sparc)
 	install -s -m 755 d-link/libdl/libdl.so debian/tmp/lib/libdl.so.$(v)
 	ln -sf libdl.so.$(v) debian/tmp/lib/libdl.so.$(vm)
 endif
-	#
-	install -d -m 755 debian/tmp/usr/man/man8
-	install -m 644 man/ldconfig.8 debian/tmp/usr/man/man8/ldconfig.8
-ifeq ($(LIBC5_SUPPORT),true)
-	install -d -m 755 debian/tmp/usr/man/man1
-	install -m 644 man/ldd.1 debian/tmp/usr/man/man1/ldd.1
-	install -d -m 755 debian/tmp/usr/man/man8
-	install -m 644 man/ld.so.8 debian/tmp/usr/man/man8/ld.so.8
-	gzip -9 debian/tmp/usr/man/man*/*
 endif
 	#
-	install -d -m 755 debian/tmp/usr/doc/ldso
-	install -m 644 README debian/tmp/usr/doc/ldso/README
-	install -m 644 debian/changelog debian/tmp/usr/doc/ldso/changelog
-	gzip -9f debian/tmp/usr/doc/ldso/*
-	install -m 644 debian/copyright debian/tmp/usr/doc/ldso/copyright
+	install -d -m 755 debian/tmp/usr/share/man/man8
+	install -m 644 man/ldconfig.8 debian/tmp/usr/share/man/man8/ldconfig.8
+ifeq ($(LIBC5_SUPPORT),true)
+	install -d -m 755 debian/tmp/usr/share/man/man1
+	install -m 644 man/ldd.1 debian/tmp/usr/share/man/man1/ldd.1
+	install -d -m 755 debian/tmp/usr/share/man/man8
+	install -m 644 man/ld.so.8 debian/tmp/usr/share/man/man8/ld.so.8
+	gzip -9 debian/tmp/usr/share/man/man*/*
+	ln -sf ld.so.8.gz debian/tmp/usr/share/man/man8/ld-linux.so.8.gz
+endif
+	#
+	install -d -m 755 debian/tmp/usr/share/doc/ldso
+	install -m 644 README debian/tmp/usr/share/doc/ldso/README
+	install -m 644 debian/changelog debian/tmp/usr/share/doc/ldso/changelog
+	gzip -9f debian/tmp/usr/share/doc/ldso/*
+	install -m 644 debian/copyright debian/tmp/usr/share/doc/ldso/copyright
 	#
 	install -d -m 755 debian/tmp/DEBIAN
 ifeq ($(LIBC5_SUPPORT),true)
@@ -103,10 +106,12 @@
 	sed -e 's/VERSION/$(VERSION)/' debian/postinst \
 		> debian/tmp/DEBIAN/postinst
 	chmod 755 debian/tmp/DEBIAN/postinst
+	install -m 755 debian/prerm debian/tmp/DEBIAN/prerm
 ifeq ($(LIBC5_SUPPORT),true)
 	install -m 644 debian/shlibs debian/tmp/DEBIAN/shlibs
 endif
 	#
+	dh_md5sums -pldso -Pdebian/tmp
 	dpkg-gencontrol -pldso
 	chmod -R g-w debian/tmp
 	chown -R root.root debian/tmp
@@ -115,6 +120,7 @@
 	##############################
 	# build the libdl1-altdev package
 ifeq ($(LIBC5_SUPPORT),true)
+ifneq ($(ARCH),sparc)
 	rm -rf debian/tmp
 	install -d -m 755 debian/tmp
 	chmod g-s debian/tmp
@@ -126,14 +132,18 @@
 	install -m 644 d-link/libdl/dlfcn.h \
 		debian/tmp/usr/$(archx)-linuxlibc1/include/dlfcn.h
 	#
-	install -d -m 755 debian/tmp/usr/doc
-	ln -sf ldso debian/tmp/usr/doc/libdl1-altdev
+	install -d -m 755 debian/tmp/usr/share/doc
+	ln -sf ldso debian/tmp/usr/share/doc/libdl1-altdev
 	#
 	install -d -m 755 debian/tmp/DEBIAN
+	install -m 755 debian/dev.postinst debian/tmp/DEBIAN/postinst
+	install -m 755 debian/dev.prerm debian/tmp/DEBIAN/prerm
+	dh_md5sums -plibdl1-altdev -Pdebian/tmp
 	dpkg-gencontrol -plibdl1-altdev
 	chmod -R g-w debian/tmp
 	chown -R root.root debian/tmp
 	dpkg --build debian/tmp ..
+endif
 endif
 
 binary: binary-indep binary-arch

## ld.so 1.9.11-15

=== debian/changelog ===
ld.so (1.9.11-15) unstable; urgency=low

  * Only build ldso for i386 and m68k architectures since a
    placeholder package is no longer needed for the others
    (Bug#88093).

 -- David Engel <david@debian.org>  Tue,  6 Mar 2001 20:17:20 -0600

ld.so (1.9.11-14) unstable; urgency=low

  * Fixed Build-Depends again^2 (Bug#87663, Bug#87664).
  * Changed section to oldlibs.

 -- David Engel <david@debian.org>  Tue, 27 Feb 2001 20:29:17 -0600

ld.so (1.9.11-13) unstable; urgency=low

  * Fixed Build-Depends again (Bug#75457).
  * Fixed typos in ld.so manpage (Bug#65633, Bug#65636).
  * Account for renaming of ldconfig.new in md5sums file 
    (Bug#66425).
  * Note that the previous two changes have no real effect since
    the modified files are no longer included.

 -- David Engel <david@debian.org>  Tue, 20 Feb 2001 20:56:17 -0600

ld.so (1.9.11-12) unstable; urgency=low

  * Fixed Build-Depends (Bug#72662).
  * Added a README.Debian file and changed the package descriptions
    to reflect the deprecated status of ldso and libdl1-altdev
    (Bug#74308).

 -- David Engel <david@debian.org>  Wed, 18 Oct 2000 20:45:35 -0500

ld.so (1.9.11-11) unstable; urgency=low

  * Changed libc6 dependencies to >=2.1.94-2.

 -- David Engel <david@debian.org>  Wed, 27 Sep 2000 22:46:24 -0500

ld.so (1.9.11-10) unstable; urgency=low

  * Removed ldconfig and ldd and associated man pages since 
    they are now in libc6.

 -- David Engel <david@debian.org>  Tue, 26 Sep 2000 20:51:41 -0500

=== debian/control ===
Source: ld.so
Section: oldlibs
Priority: optional
Maintainer: David Engel <david@debian.org>
Standards-Version: 2.4.0.0
Build-Depends: libc6-dev (>=2.1.94-2), altgcc (>=2.7.2.3), libc5-altdev (>=5.4.0), sharutils, debhelper

Package: ldso
Section: oldlibs
Priority: optional
Architecture: i386 m68k
Provides: libdl1
Replaces: libc6
Depends: libc6 (>=2.1.94)
Description: The Linux dynamic linker and library for libc4 and libc5.
 This dynamic linker provides the user-level support for loading and
 linking DLL and ELF shared libraries.  You do not need this package
 unless you have very old programs which use libc4 or libc5.  The libc6
 package has its own dynamic linker that is used for all current 
 programs.

Package: libdl1-altdev
Section: oldlibs
Priority: optional
Architecture: i386 m68k
Depends: ldso (=${Source-Version}), libc5-altdev (>=5.4.0-0)
Description: The Linux dynamic linker library (libc5 altdev files).
 This package can be used to build libc5-based binaries even when 
 the libc6-dev package is installed.  You do not need this package
 unless you are rebuilding very old programs which use libc5.  The
 libc6-dev package contains its own dynamic linker library that should
 be used to  rebuild current programs.

=== debian/rules ===
--- 
+++ 
@@ -52,13 +52,13 @@
 	install -d -m 755 debian/tmp
 	chmod g-s debian/tmp
 	#
-	install -d -m 755 debian/tmp/sbin
-	install -s -m 755 util/ldconfig debian/tmp/sbin/ldconfig.new
+	#install -d -m 755 debian/tmp/sbin
+	#install -s -m 755 util/ldconfig debian/tmp/sbin/ldconfig.new
 ifeq ($(LIBC5_SUPPORT),true)
-	install -d -m 755 debian/tmp/usr/bin
-	install -s -m 755 util/ldd debian/tmp/usr/bin/ldd
-	install -d -m 755 debian/tmp/usr/lib
-	install -s -m 755 util/lddstub debian/tmp/usr/lib/lddstub
+	#install -d -m 755 debian/tmp/usr/bin
+	#install -s -m 755 util/ldd debian/tmp/usr/bin/ldd
+	#install -d -m 755 debian/tmp/usr/lib
+	#install -s -m 755 util/lddstub debian/tmp/usr/lib/lddstub
 endif
 ifeq ($(AOUT_SUPPORT),true)
 	install -d -m 755 debian/tmp/lib
@@ -75,19 +75,20 @@
 endif
 endif
 	#
-	install -d -m 755 debian/tmp/usr/share/man/man8
-	install -m 644 man/ldconfig.8 debian/tmp/usr/share/man/man8/ldconfig.8
+	#install -d -m 755 debian/tmp/usr/share/man/man8
+	#install -m 644 man/ldconfig.8 debian/tmp/usr/share/man/man8/ldconfig.8
 ifeq ($(LIBC5_SUPPORT),true)
-	install -d -m 755 debian/tmp/usr/share/man/man1
-	install -m 644 man/ldd.1 debian/tmp/usr/share/man/man1/ldd.1
-	install -d -m 755 debian/tmp/usr/share/man/man8
-	install -m 644 man/ld.so.8 debian/tmp/usr/share/man/man8/ld.so.8
-	gzip -9 debian/tmp/usr/share/man/man*/*
-	ln -sf ld.so.8.gz debian/tmp/usr/share/man/man8/ld-linux.so.8.gz
+	#install -d -m 755 debian/tmp/usr/share/man/man1
+	#install -m 644 man/ldd.1 debian/tmp/usr/share/man/man1/ldd.1
+	#install -d -m 755 debian/tmp/usr/share/man/man8
+	#install -m 644 man/ld.so.8 debian/tmp/usr/share/man/man8/ld.so.8
+	#gzip -9 debian/tmp/usr/share/man/man*/*
+	#ln -sf ld.so.8.gz debian/tmp/usr/share/man/man8/ld-linux.so.8.gz
 endif
 	#
 	install -d -m 755 debian/tmp/usr/share/doc/ldso
 	install -m 644 README debian/tmp/usr/share/doc/ldso/README
+	install -m 644 debian/README.Debian debian/tmp/usr/share/doc/ldso/README.Debian
 	install -m 644 debian/changelog debian/tmp/usr/share/doc/ldso/changelog
 	gzip -9f debian/tmp/usr/share/doc/ldso/*
 	install -m 644 debian/copyright debian/tmp/usr/share/doc/ldso/copyright
@@ -139,6 +140,8 @@
 	install -m 755 debian/dev.postinst debian/tmp/DEBIAN/postinst
 	install -m 755 debian/dev.prerm debian/tmp/DEBIAN/prerm
 	dh_md5sums -plibdl1-altdev -Pdebian/tmp
+	# Handle rename of ldconfig.new to ldconfig
+	perl -p -i -e 's/ldconfig\.new/ldconfig/' debian/ldso/DEBIAN/md5sums
 	dpkg-gencontrol -plibdl1-altdev
 	chmod -R g-w debian/tmp
 	chown -R root.root debian/tmp
